Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 736)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 737)
@@ -52,6 +52,7 @@
 import org.txm.rcp.swt.widget.PropertiesSelector;
 import org.txm.rcp.swt.widget.QueryWidget;
 import org.txm.rcp.utils.JobHandler;
+import org.txm.rcp.utils.SWTEditorsUtils;
 import org.txm.rcp.views.corpora.CorporaView;
 import org.txm.rcp.views.debug.TXMResultDebugView;
 import org.txm.searchengine.cqp.corpus.Property;
@@ -196,10 +197,6 @@
 			this._createPartControl(parent); // child editor create its parameters and display widgets
 			
 			
-			if (!this.getResult().isDirty()) {
-				this.topToolBar.setComputingParametersVisible(false);
-			}
-			
 			// remove empty toolbar
 			//TODO SJ: Hack? MD: yeah -> need to find a way to not display the bottom toolbar on Windows instead
 //			if (this.bottomToolBar.getItems().length == 0) {
@@ -383,57 +380,25 @@
 		return this.getEditorInput().getResult().getStringParameterValue(key);
 	}
 
-	//// TODO commented for now ?	
-	//	/**
-	//	 * Computes the result stored in the specified editor input and opens an editor specified by its id.
-	//	 * @param editorInput
-	//	 * @param editorPartId
-	//	 * @return
-	//	 */
-	//	public static void openEditor(TXMResultEditorInput editorInput, String editorPartId)	{
-	//		compute(editorInput, editorPartId, false, null);
-	//	}
 
 	/**
-	 * Computes specified result stored, creates an editor input and opens an editor specified by its id.
+	 * Computes the TXMResult if all necessary parameters are set then refreshes the editor UI.
+	 * Also loads and savesd some parameters from result to Widgets fields and from Widgets fields to result.
 	 * 
-	 * Always creates an editor
-	 * 
 	 * @param result
-	 * @param editorPartId
-	 */
-	public static void openEditor(TXMResult result, String editorPartId)	{
-		//openEditor(new TXMResultEditorInput(result), editorPartId);
-		compute(new TXMResultEditorInput(result), editorPartId, false, null);
-	}
-
-	/**
-	 * Computes the TXMResult If all necessary parameters are set AND refresh the editor UI
-	 *  
-	 * @param update transfered to the TXMResult.compute method
-	 */
-	public final void compute(boolean update) {
-		compute(this.getEditorInput(), null, update, this);
-	}
-
-	/**
-	 * Internal method to mutualise compute editor creation
-	 * 
-	 * @param result
 	 * @param update force the editor to update its result parameters
 	 * @param editor
 	 * @param chartsComponentsProvider
 	 * @param resetView
 	 * @param clearChartItemsSelection
 	 */
-	protected static void compute(final TXMResultEditorInput<? extends TXMResult> editorInput, final String editorId, final boolean update, final TXMEditor<? extends TXMResult> editor)	{
+	public JobHandler compute(final boolean update)	{
 
-		StatusLine.setMessage("Computing " + editorInput.getResult().getName());
+		
+		StatusLine.setMessage("Computing " + this.getResult().getName());
 
-		JobHandler job = new JobHandler("Computing " + editorInput.getResult().getName()) {
+		JobHandler job = new JobHandler("Computing " + this.getResult().getName()) {
 
-			TXMEditor<? extends TXMResult> currentEditor = null;
-
 			@Override
 			protected IStatus run(IProgressMonitor monitor) {
 
@@ -442,68 +407,62 @@
 				try {
 					JobsTimer.start();
 
-					currentEditor = editor;
-
-					// FIXME: define if we update here the result from the editor fields
-					if (currentEditor != null)	{
-						this.syncExec(new Runnable() {
-							@Override
-							public void run() {
+					this.syncExec(new Runnable() {
+						@Override
+						public void run() {
+							if(update)	{
 								// FIXME: DEbug
 								System.err.println("TXMEditor.compute(): manually updating result from editor.");
-								currentEditor.updateResultFromEditor(); // subclasses manual settings
+								updateResultFromEditor(); // subclasses manual result updating from editor fields
 								// FIXME: DEbug
 								System.err.println("TXMEditor.compute(): auto updating result from editor.");
-								currentEditor.autoUpdateResultFromEditorParameters(); // auto update from Parameter annotations
+								autoUpdateResultFromEditorParameters(); // auto updating result from Parameter annotations in result <=> editor
 								
 								// Stores the last parameters before the computing to later auto-update the Widgets only if some parameters have changed 
-								currentEditor.setLastComputingParameters(editorInput.getResult().getLastParameters());
-
+								setLastComputingParameters(TXMEditor.this.getResult().getLastParameters());
 							}
-						});
-					}
+						}
+					});
 
 
 					// computing result
 					monitor.beginTask("Computing", 100);
-
 					
-					if (!editorInput.getResult().compute(monitor)) {
+					if (!TXMEditor.this.getResult().compute(monitor)) {
 						Log.info("TXMEditor.compute(): computing failed.");
 					}
 
 					monitor.worked(50);
 
+					// FIXME: old version
 					// opening an editor if not exists
-					if (currentEditor == null && editorId != null)	{
-						this.syncExec(new Runnable() {
-							@Override
-							public void run() {
-								try {
+//					if (currentEditor == null && editorId != null)	{
+//						this.syncExec(new Runnable() {
+//							@Override
+//							public void run() {
+//								try {
+//
+//									Log.info("TXMEditor.compute(): opening editor with id: " + editorId);
+//
+//									IWorkbenchWindow window = TXMWindows.getActiveWindow();
+//									IWorkbenchPage page = window.getActivePage();
+//									currentEditor = (TXMEditor) page.openEditor(editorInput, editorId, true, IWorkbenchPage.MATCH_INPUT | IWorkbenchPage.MATCH_ID);
+//								}
+//								catch (Exception e) {
+//									System.err.println("TXMEditor.compute(): could not open editor: " + e.getLocalizedMessage());
+//									Log.printStackTrace(e);
+//								}
+//							}
+//						});
+//					}
 
-									Log.info("TXMEditor.compute(): opening editor with id: " + editorId);
-
-									IWorkbenchWindow window = TXMWindows.getActiveWindow();
-									IWorkbenchPage page = window.getActivePage();
-									currentEditor = (TXMEditor) page.openEditor(editorInput, editorId, true, IWorkbenchPage.MATCH_INPUT | IWorkbenchPage.MATCH_ID);
-								}
-								catch (Exception e) {
-									System.err.println("TXMEditor.compute(): could not open editor: " + e.getLocalizedMessage());
-									Log.printStackTrace(e);
-								}
-							}
-						});
-					}
-
 					// refreshing the UI
-					if (currentEditor != null)	{
-						this.syncExec(new Runnable() {
-							@Override
-							public void run() {
-								currentEditor.refresh(update);
-							}
-						});
-					}
+					this.syncExec(new Runnable() {
+						@Override
+						public void run() {
+							refresh(update);
+						}
+					});
 					
 					
 					
@@ -512,6 +471,8 @@
 				catch (ThreadDeath td) {
 					// FIXME should call clean() and/or set the result as dirty?
 					return Status.CANCEL_STATUS;
+					// FIXME: SJ tests
+					// throw td;
 				}
 				catch (Exception e) {
 					Log.printStackTrace(e);
@@ -524,99 +485,66 @@
 			}
 		};
 		job.setPriority(Job.DECORATE);
+		//job.setPriority(Job.INTERACTIVE);
 		job.setUser(false);
 		job.schedule();
+		return job;
 	}
 
-	// FIXME: old code	
-	//	/**
-	//	 * Computes and creates or updates the result (from the linked editor input data).
-	//	 * @param update set if it's an update on an existing result or a creation of a new result 
-	//	 */
-	//	public void computeResult() {
-	//		final TXMResult result = this.getResultData();
-	//		StatusLine.setMessage("Computing "+result.getName());
-	//		//final TXMParameters parameters = this.getParameters();
-	//		final String title = result.getName()+"...";
-	//		try {
-	//			JobHandler jobhandler = new JobHandler(title, topToolBar) {
-	//				@Override
-	//				protected IStatus run(IProgressMonitor monitor) {
-	//					this.runInit(monitor);
-	//					try {
-	//						JobsTimer.start();
-	//
-	//						//result.setParameters(parameters);
-	//
-	//						if (result.canCompute() && result.isDirty()) {
-	//
-	//							String title = "";//result.getComputingMessage();
-	//							System.out.println(title);
-	//							Log.info("Start computing Index...");
-	//
-	//							result.compute(true, monitor);
-	//						} else {
-	//							return Status.CANCEL_STATUS;
-	//						}
-	//
-	//						if (monitor.isCanceled())
-	//							return Status.CANCEL_STATUS;
-	//
-	//						final String message = "";//result.getComputingEndMessage();
-	//
-	//						if (monitor.isCanceled())
-	//							return Status.CANCEL_STATUS;
-	//
-	//						monitor.worked(95);
-	//						// refresh ui
-	//						syncExec(new Runnable() {
-	//							@Override
-	//							public void run() {
-	//
-	//								System.out.println(message);
-	//								StatusLine.setMessage(message);
-	//
-	//								refresh();
-	//
-	//								RestartTXM.reloadViews();
-	//							}
-	//						});
-	//
-	//					} catch (ThreadDeath td) {
-	//						return Status.CANCEL_STATUS;
-	//					} catch (Exception e) {
-	//						//System.out.println(result.getComputingErrorMessage());
-	//						System.out.println(e.getLocalizedMessage());
-	//						Log.printStackTrace(e);
-	//					} finally {
-	//						monitor.done();
-	//						JobsTimer.stopAndPrint();
-	//					}
-	//					return Status.OK_STATUS;
-	//				}
-	//			};
-	//			jobhandler.startJob();
-	//
-	//		} catch (Exception e1) {
-	//			org.txm.rcp.utils.Logger.printStackTrace(e1);
-	//		}
-	//	}
+	/**
+	 * Opens an editor specified by its id, computes the specified result then refreshes the editor components.
+	 * 
+	 * @param result
+	 * @param editorPartId
+	 */
+	public static TXMEditor openEditor(TXMResult result, String editorPartId)	{
+		return openEditor(new TXMResultEditorInput<TXMResult>(result), editorPartId);
+	}
 
+
 	/**
+	 * Opens an editor specified by its id, computes the result stored in the specified editor input then refreshes the editor components.
+	 * @param editorInput
+	 * @param editorId
+	 * @return
+	 */
+	public static TXMEditor openEditor(TXMResultEditorInput editorInput, String editorId)	{
+		TXMEditor editor = null;
+		IWorkbenchWindow window = TXMWindows.getActiveWindow();
+		IWorkbenchPage page = window.getActivePage();
+		try {
+			boolean wasAlreadyOpened = SWTEditorsUtils.isOpenEditor(editorInput, editorId);
+			// opening the editor
+			editor = (TXMEditor) page.openEditor(editorInput, editorId, true, IWorkbenchPage.MATCH_INPUT | IWorkbenchPage.MATCH_ID);
+			// computing the result only if the editor wasn't already opened
+			if(!wasAlreadyOpened)	{
+				editor.compute(false);
+			}
+		}
+		catch (PartInitException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		return editor;
+	}
+	
+	
+	/**
 	 * Synchronizes the editor with the result and refreshes the corpus view.
 	 * Also fires a dirty property change.
-	 * This method should be overridden to update the editor result UI area after the result computing.
 	 * @param update
 	 */
 	public final void refresh(boolean update)	{
+		// FIXME: result should never be null?
 		if (this.getResult() != null) {
+			
 			this.setPartName(this.getResult().getName());
 			this.firePropertyChange(TXMEditor.PROP_DIRTY);
 			
 			//MD commented 'if (!update) {...}'
 			// SJ need to check all works, it also was dedicated to not refresh the Editor from result after a computing, it's not needed since the computing has been done
 			// from fields themselves
-			if (!update) {
+			//if (!update) {
 				// FIXME: debug
 				System.err.println("TXMEditor.refresh(): auto updating editor from result.");
 				this.autoUpdateEditorFieldsFromResult(update); // auto update from Parameter annotations
@@ -624,12 +552,15 @@
 				// FIXME: debug
 				System.err.println("TXMEditor.refresh(): updating subclass editor (" + getClass().getSimpleName() + ") from result.");
 				this.updateEditorFromResult(update); // subclasses manual settings
+			//}
+				
+			// Hide the computing parameter area if the editor wasn't open and the result is computed
+			if (!update) {
+				if (!this.getResult().isDirty()) {
+					this.topToolBar.setComputingParametersVisible(false);
+				}
 			}
 				
-				// FIXME: became useless?
-			//this.__updateEditorFromResult(update); // essentially for ChartEditor
-			
-			
 			topToolBar.redraw();
 			CorporaView.refreshObject(this);
 			TXMResultDebugView.refreshView();
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeKeyListener.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeKeyListener.java	(revision 736)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeKeyListener.java	(revision 737)
@@ -29,7 +29,7 @@
 	@Override
 	public void keyPressed(KeyEvent e) {
 		if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-			this.editor.compute(false);
+			this.editor.compute(true);
 		}
 		// FIXME: update the result from the widget
 		// purpose here is, for example, to enable the compute command button when a query is typed
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeListener.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeListener.java	(revision 736)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeListener.java	(revision 737)
@@ -26,7 +26,7 @@
 	@Override
 	public void handleEvent(Event event) {
 		if (TXMPreferences.getBoolean(RCPPreferences.AUTO_UPDATE_EDITOR, RCPPreferences.PREFERENCES_NODE)) {
-			this.editor.compute(false);
+			this.editor.compute(true);
 		}
 	}
 
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeSelectionListener.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeSelectionListener.java	(revision 736)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/listeners/ComputeSelectionListener.java	(revision 737)
@@ -29,7 +29,7 @@
 
 	@Override
 	public void widgetSelected(SelectionEvent e) {
-		this.editor.compute(false);
+		this.editor.compute(true);
 	}
 
 	@Override
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/structures/StructuralUnitPropertiesComboViewer.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/structures/StructuralUnitPropertiesComboViewer.java	(revision 736)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/structures/StructuralUnitPropertiesComboViewer.java	(revision 737)
@@ -7,6 +7,7 @@
 import org.eclipse.swt.widgets.Composite;
 import org.txm.core.results.TXMResult;
 import org.txm.rcp.editors.TXMEditor;
+import org.txm.rcp.editors.listeners.ComputeSelectionListener;
 import org.txm.searchengine.cqp.corpus.StructuralUnit;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
 
@@ -29,8 +30,15 @@
 	 * @param addBlankEntry to add an empty blank entry at start of the list to clear property.
 	 */
 	public StructuralUnitPropertiesComboViewer(Composite parent, int style, TXMEditor<? extends TXMResult> editor, boolean autoCompute, StructuralUnit su, StructuralUnitProperty selectedSUP, boolean addBlankEntry) {
-		super(parent, style, editor, autoCompute, null, null, addBlankEntry);
+		super(parent, style, editor, false, null, null, addBlankEntry);
 		this.updateFromStructuralUnit(su, selectedSUP);
+		
+		// Listener
+		if(autoCompute)	{
+			this.addSelectionChangedListener(new ComputeSelectionListener(editor));
+		}
+
+		
 	}
 
 	
Index: tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/handlers/ComputeCooccurrences.java
===================================================================
--- tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/handlers/ComputeCooccurrences.java	(revision 736)
+++ tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/handlers/ComputeCooccurrences.java	(revision 737)
@@ -39,12 +39,8 @@
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.rcp.StatusLine;
 import org.txm.rcp.editors.TXMEditor;
-import org.txm.rcp.editors.TXMResultEditorInput;
 import org.txm.rcp.handlers.BaseAbstractHandler;
 import org.txm.rcp.messages.TXMUIMessages;
-import org.txm.rcp.utils.Logger;
-import org.txm.rcp.views.corpora.CorporaView;
-import org.txm.searchengine.cqp.CQPEngine;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.StructuralUnit;
@@ -52,21 +48,15 @@
 import org.txm.utils.logger.Log;
 
 /**
- * if the selection is a corpus, open an empty Cooc editor if the selection is a concordance, open a Cooc editor already computed.
+ * If the selection is a corpus, opens an empty Cooc editor,
+ * if the selection is a concordance, opens a Cooc editor already computed.
  * 
  * @author mdecorde
  * 
  */
 public class ComputeCooccurrences extends BaseAbstractHandler {
 	
-	// adds a double click listener to the Corpus View
-	static	{
-		CorporaView.addDoubleClickListener(Cooccurrence.class, ComputeCooccurrences.class);
-	}
 	
-	/* (non-Javadoc)
-	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
-	 */
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 		
Index: tmp/org.txm.ca.rcp/src/org/txm/ca/rcp/handlers/ComputeCA.java
===================================================================
--- tmp/org.txm.ca.rcp/src/org/txm/ca/rcp/handlers/ComputeCA.java	(revision 736)
+++ tmp/org.txm.ca.rcp/src/org/txm/ca/rcp/handlers/ComputeCA.java	(revision 737)
@@ -46,34 +46,21 @@
 import org.txm.rcp.editors.TXMResultEditorInput;
 import org.txm.rcp.handlers.BaseAbstractHandler;
 import org.txm.rcp.messages.TXMUIMessages;
-import org.txm.rcp.views.corpora.CorporaView;
 import org.txm.searchengine.cqp.corpus.Partition;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.utils.logger.Log;
 import org.txm.utils.logger.MessageBox;
 
 /**
- * if the selection is a lexical table : opens the CA if the selection is a
- * partition : ask the user which property used and which threshold used then
- * open the CaEditor
+ * If the selection is a lexical table: opens the CA,
+ * if the selection is a partition: asks the user which property used and which threshold used then opens an editor
  * 
  * @author mdecorde
  * @author sjacquot
  */
 public class ComputeCA extends BaseAbstractHandler {
 
-	// adds a double click listener to the Corpus View
-	static {
-		CorporaView.addDoubleClickListener(CA.class, ComputeCA.class);
-	}
 
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see
-	 * org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands
-	 * .ExecutionEvent)
-	 */
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 
Index: tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEngines.java
===================================================================
--- tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEngines.java	(revision 736)
+++ tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEngines.java	(revision 737)
@@ -8,12 +8,25 @@
 import org.txm.EnginesManager;
 import org.txm.Toolbox;
 
+/**
+ * 
+ * @author mdecorde
+ *
+ */
 public class SearchEngines extends EnginesManager<SearchEngine> {
 
+	/**
+	 * 
+	 * @return
+	 */
 	public static SearchEngine getCQPEngine() {
 		return (SearchEngine) Toolbox.getEngineManager(EngineType.SEARCH).getEngine("CQP");
 	}
 
+	/**
+	 * 
+	 * @return
+	 */
 	public static SearchEngine getTIGERSearchEngine() {
 		return (SearchEngine) Toolbox.getEngineManager(EngineType.SEARCH).getEngine("TIGERSearch");
 	}
@@ -28,11 +41,12 @@
 				SearchEngine e = (SearchEngine)contributions[i].createExecutableExtension("class"); //$NON-NLS-1$
 				if (e.initialize()) {
 					engines.put(e.getName(), e);
-				} else {
-					System.out.println("Fail to initialize "+e.getName()+" search engine.");
 				}
+				else {
+					System.out.println("Fail to initialize " + e.getName() + " search engine.");
+				}
 			} catch(Exception e) {
-				System.out.println("Error: fail to instanciate "+contributions[i].getName()+": "+e.getLocalizedMessage());
+				System.out.println("Error: fail to instanciate " + contributions[i].getName() + ": " + e.getLocalizedMessage());
 				e.printStackTrace();
 			}
 		}
@@ -51,11 +65,13 @@
 		for (Engine e : engines.values()) {
 			SearchEngine se = (SearchEngine)e;
 			//System.out.println("Starting "+ se.getName()+" searchengine.");
-			if (monitor != null) monitor.subTask("Starting "+ se.getName()+" searchengine.");
+			if (monitor != null) {
+				monitor.subTask("Starting " + se.getName() + " searchengine.");
+			}
 			try {
 				se.start(monitor);
 			} catch (Exception e2) {
-				System.out.println("Error: fail to start SearchEngine: "+se.getName()+": "+e2.getLocalizedMessage());
+				System.out.println("Error: fail to start SearchEngine: " + se.getName() + ": " + e2.getLocalizedMessage());
 			}
 		}
 		return true;
@@ -71,7 +87,7 @@
 			try {
 				se.stop();
 			} catch (Exception e2) {
-				System.out.println("Error: fail to stop SearchEngine: "+se.getName()+": "+e2.getLocalizedMessage());
+				System.out.println("Error: fail to stop SearchEngine: " + se.getName() + ": " + e2.getLocalizedMessage());
 			}
 		}
 		return true;
Index: tmp/org.txm.core/src/java/org/txm/Toolbox.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 736)
+++ tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 737)
@@ -34,6 +34,8 @@
 import java.io.FileNotFoundException;
 import java.io.IOException;
 import java.io.InputStreamReader;
+import java.lang.reflect.Constructor;
+import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.LinkedHashMap;
 import java.util.logging.Level;
@@ -45,6 +47,7 @@
 import org.eclipse.core.runtime.ISafeRunnable;
 import org.eclipse.core.runtime.Platform;
 import org.eclipse.core.runtime.SafeRunner;
+import org.osgi.framework.Bundle;
 import org.eclipse.core.runtime.preferences.DefaultScope;
 import org.eclipse.core.runtime.preferences.IPreferencesService;
 import org.txm.core.messages.TXMCoreMessages;
@@ -234,6 +237,32 @@
 		} catch(Exception e) {
 			System.out.println("Error while post-installaing plugins: "+e.getLocalizedMessage());
 		}
+		
+		
+		// FIXME: persistence tests
+		if (TBXPreferences.getBoolean(TBXPreferences.AUTO_SAVE_RESULTS, TBXPreferences.PREFERENCES_NODE)) {
+			System.out.println("Toolbox.initialize(): reloading persitent results...");
+			ArrayList<String> resultsNodesQualifiers = TXMPreferences.getResultsNodesQualifiers();
+			for (String nodeQualifier : resultsNodesQualifiers) {
+				try {
+					System.out.println("Toolbox.initialize(): loading from result node qualifier " + nodeQualifier);
+					System.out.println("Toolbox.initialize(): class =  " + TXMPreferences.getString("class", nodeQualifier));
+					System.out.println("Toolbox.initialize(): parent_uuid =  " + TXMPreferences.getString(TXMPreferences.PARENT_UUID, nodeQualifier));
+					System.out.println("Toolbox.initialize(): bundle_id =  " + TXMPreferences.getString(TXMPreferences.BUNDLE_ID, nodeQualifier));
+					Bundle bundle = Platform.getBundle(TXMPreferences.getString(TXMPreferences.BUNDLE_ID, nodeQualifier));
+					Class<?> cl = bundle.loadClass(TXMPreferences.getString("class", nodeQualifier));
+					Constructor<?> cons = cl.getConstructor(String.class);
+					cons.newInstance(nodeQualifier);
+				}
+				catch (Exception e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+		}
+		
+		
+		
 		initializing = false;
 		return checkState();
 	}
Index: tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java	(revision 736)
+++ tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java	(revision 737)
@@ -68,8 +68,10 @@
 	 */
 	public final static String DEFAULT_UNIT_PROPERTY = "word"; //$NON-NLS-1$
 
+	// essentially for Links and Persistence
 	public final static String RESULT_UUID = "result_uuid"; //$NON-NLS-1$
 	public final static String PARENT_UUID = "parent_uuid"; //$NON-NLS-1$
+	public final static String BUNDLE_ID = "bundle_id"; //$NON-NLS-1$
 
 	// to shared strings in some preferences
 	/**
@@ -881,7 +883,7 @@
 				}
 			}
 		} catch (Exception e) {
-			System.err.println(e);
+			e.printStackTrace();;
 		}
 	}
 
@@ -917,6 +919,35 @@
 	}
 
 	/**
+	 * Gets all the result nodes qualifier (from *.prefs file starting with "txm_res").
+	 * @return
+	 */
+	public static ArrayList<String> getResultsNodesQualifiers()	{
+		ArrayList<String> resultsNodesQualifiers = new ArrayList<String>();
+		try {
+			IPreferencesService service = Platform.getPreferencesService();
+			for (String scopeName : service.getRootNode().childrenNames()) {
+				if(scopeName != TXMPreferences.scope.getName())	{
+					continue;
+				}
+					
+				String[] nodesNames = service.getRootNode().node(scopeName).childrenNames();
+				Arrays.sort(nodesNames);
+				for (String nodeName : nodesNames) {
+					if(nodeName.startsWith("txm_res_"))	{
+						resultsNodesQualifiers.add(nodeName);
+					}
+				}
+			}
+		} catch (Exception e) {
+			e.printStackTrace();;
+		}
+
+		return resultsNodesQualifiers;
+	}
+	
+	
+	/**
 	 * 
 	 * @param nodeQualifier
 	 * @throws BackingStoreException 
Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditor.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditor.java	(revision 736)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditor.java	(revision 737)
@@ -14,7 +14,10 @@
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Group;
 import org.eclipse.ui.IPartListener;
+import org.eclipse.ui.IWorkbenchPage;
 import org.eclipse.ui.IWorkbenchPart;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.PartInitException;
 import org.eclipse.ui.PlatformUI;
 import org.eclipse.ui.part.EditorPart;
 import org.eclipse.ui.part.MultiPageEditorPart;
@@ -27,7 +30,10 @@
 import org.txm.chartsengine.rcp.swt.AdvancedChartEditorToolBar;
 import org.txm.chartsengine.rcp.swt.ChartComposite;
 import org.txm.chartsengine.rcp.swt.ChartEditorToolBar;
+import org.txm.core.results.TXMResult;
+import org.txm.rcp.TXMWindows;
 import org.txm.rcp.editors.TXMEditor;
+import org.txm.rcp.editors.TXMResultEditorInput;
 import org.txm.utils.logger.Log;
 
 /**
@@ -170,7 +176,7 @@
 	
 
 	/**
-	 * 
+	 * Opens an editor where id is the specified result class name, computes the result then refreshes the editor components.
 	 * @param result
 	 */
 	public static void openEditor(ChartResult result) {
@@ -179,12 +185,17 @@
 
 	
 	/**
-	 * 
+	 * Opens an editor specified by its id, computes the specified result then refreshes the editor components.
 	 * @param result
 	 * @param editorPartId
+	 * @return
 	 */
-	public static void openEditor(ChartResult result, String editorPartId)	{
-		compute(new ChartEditorInput(result), editorPartId, false, null);
+	public static ChartEditor openEditor(ChartResult result, String editorPartId)	{
+		
+		// FIXME: voir si on peut pas revenir à l'ouverture de l'éditeur ICI plutot que dans le compute, ca permettrait de retourner le TXMEditor dans openEditor()
+		return (ChartEditor) openEditor(new ChartEditorInput<ChartResult>(result), editorPartId);
+				
+		//compute(new ChartEditorInput<ChartResult>(result), editorPartId, false, null);
 	}
 
 
@@ -225,13 +236,19 @@
 
 		
 		
+		boolean needInit = (this.chartComposite.getChartComponent() == null) && (this.getResult().getChart() != null);
+		
 		// loading chart
 		this.getResult().subTask("Loading chart.");
 		this.loadChart();
 		
 		// if editor wasn't exist:
 		// hiding command parameters, updating tool bar buttons states, registering context menus and event user callbacks 
-		if(!update && !getResult().isChartDirty())	{
+		if(needInit
+				
+				//!update
+//				&& !this.getResult().isChartDirty()
+				)	{
 //			getSite().getShell().getDisplay().syncExec(new Runnable() {
 //				@Override
 //				public void run() {
@@ -269,7 +286,7 @@
 	/**
 	 * Registers user entries event call back extensions.
 	 */
-	protected void registerEventCallBackExtensions()	{
+	public void registerEventCallBackExtensions()	{
 		String extensionPointId = "org.txm.chartsengine.eventcallback"; //$NON-NLS-1$
 		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(extensionPointId);
 		
Index: tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/handlers/ComputeTextsBalance.java
===================================================================
--- tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/handlers/ComputeTextsBalance.java	(revision 736)
+++ tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/handlers/ComputeTextsBalance.java	(revision 737)
@@ -45,14 +45,6 @@
 public class ComputeTextsBalance extends BaseAbstractHandler {
 
 
-	
-	// adds a double click listener to the Corpus View
-	static	{
-		CorporaView.addDoubleClickListener(TextsBalance.class, ComputeTextsBalance.class);
-	}
-	
-	
-
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 
Index: tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/handlers/ComputeReferencer.java
===================================================================
--- tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/handlers/ComputeReferencer.java	(revision 736)
+++ tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/handlers/ComputeReferencer.java	(revision 737)
@@ -31,7 +31,6 @@
 import org.eclipse.core.commands.ExecutionException;
 import org.txm.rcp.editors.TXMEditor;
 import org.txm.rcp.handlers.BaseAbstractHandler;
-import org.txm.rcp.views.corpora.CorporaView;
 import org.txm.referencer.core.functions.Referencer;
 import org.txm.referencer.rcp.editors.ReferencerEditor;
 import org.txm.searchengine.cqp.corpus.Corpus;
@@ -44,11 +43,6 @@
  */
 public class ComputeReferencer extends BaseAbstractHandler {
 	
-	// adds a double click listener to the Corpus View
-	static	{
-		CorporaView.addDoubleClickListener(Referencer.class, ComputeReferencer.class);
-	}
-	
 
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
@@ -72,7 +66,7 @@
 			return super.logCanNotCompute(selection);
 		}
 		
-		TXMEditor.openEditor(referencer, ReferencerEditor.ID); //$NON-NLS-1$
+		TXMEditor.openEditor(referencer, ReferencerEditor.class.getName());
 		
 		return null;
 	}
